Package: censusapi
Version: 0.9.0
Title: Retrieve Data from the Census APIs
Authors@R: person("Hannah", "Recht", email = "censusapi.rstats@gmail.com", role = c("aut", "cre"))
Description: A wrapper for the U.S. Census Bureau APIs that returns data frames of 
	Census data and metadata. Available datasets include the 
	Decennial Census, American Community Survey, Small Area Health Insurance Estimates,
	Small Area Income and Poverty Estimates, Population Estimates and Projections, and more.
URL: https://www.hrecht.com/censusapi/,
        https://github.com/hrecht/censusapi
BugReports: https://github.com/hrecht/censusapi/issues
Depends: R (>= 3.5)
License: GPL-3
LazyData: true
RoxygenNote: 7.3.2
Imports: httr, jsonlite, rlang
Suggests: knitr, rmarkdown
Encoding: UTF-8
VignetteBuilder: knitr
NeedsCompilation: no
Packaged: 2025-03-05 20:42:58 UTC; hrecht
Author: Hannah Recht [aut, cre]
Maintainer: Hannah Recht <censusapi.rstats@gmail.com>
Repository: CRAN
Date/Publication: 2025-03-05 21:10:02 UTC
Built: R 4.3.3; ; 2025-03-05 21:57:30 UTC; unix

Package: censusapi
Version: 0.10.0
Title: Retrieve Data from the Census APIs
Authors@R: person("Hannah", "Recht", email = "censusapi.rstats@gmail.com", role = c("aut", "cre"))
Description: A wrapper for the U.S. Census Bureau APIs that returns data frames of 
	Census data and metadata. Available datasets include the 
	Decennial Census, American Community Survey, Small Area Health Insurance Estimates,
	Small Area Income and Poverty Estimates, Population Estimates and Projections, and more.
URL: https://www.hrecht.com/censusapi/,
        https://github.com/hrecht/censusapi
BugReports: https://github.com/hrecht/censusapi/issues
Depends: R (>= 3.5)
License: GPL-3
LazyData: true
Imports: httr, jsonlite, rlang
Suggests: knitr, rmarkdown
Encoding: UTF-8
VignetteBuilder: knitr
Config/roxygen2/version: 8.0.0
NeedsCompilation: no
Packaged: 2026-05-12 17:16:05 UTC; hrecht
Author: Hannah Recht [aut, cre]
Maintainer: Hannah Recht <censusapi.rstats@gmail.com>
Repository: CRAN
Date/Publication: 2026-05-13 11:30:10 UTC
Built: R 4.5.2; ; 2026-05-13 14:00:27 UTC; unix

# censusapi

<!-- badges: start -->
[![CRAN status](https://www.r-pkg.org/badges/version/censusapi)](https://CRAN.R-project.org/package=censusapi)
[![Development version](https://img.shields.io/github/r-package/v/hrecht/censusapi?label=Development%20version&color=yellow)](https://img.shields.io/github/r-package/v/hrecht/censusapi?label=Development%20version&color=yellow)
[![CRAN downloads badge](https://cranlogs.r-pkg.org:443/badges/grand-total/censusapi)](https://cranlogs.r-pkg.org:443/badges/grand-total/censusapi)
[![R-CMD-check](https://github.com/hrecht/censusapi/actions/workflows/R-CMD-check.yaml/badge.svg)](https://github.com/hrecht/censusapi/actions/workflows/R-CMD-check.yaml)
<!-- badges: end -->

`censusapi` is a lightweight package to get data from the U.S. Census Bureau's [APIs](https://www.census.gov/data/developers.html). More than 1,500 API endpoints are available, including data from surveys such as the Decennial Census, American Community Survey, International Trade Datasets, Small Area Health Insurance Estimates and the Economics Indicators Time Series. `getCensus()` lets users retrieves data from any of those datasets using simple, consistent syntax.

The package also includes metadata functions to help users determine [which datasets](https://www.hrecht.com/censusapi/reference/listCensusApis.html) are available and the variable, geography, and other options in [each of them](https://www.hrecht.com/censusapi/reference/listCensusMetadata.html).

## Installation
Get the latest stable release from CRAN: 
```R
install.packages("censusapi")
```

You can also install the latest development version of `censusapi` from Github using `devtools`:
```R
# Install the devtools package if needed
# install.packages("devtools")
devtools::install_github("hrecht/censusapi")
```

## Basic usage
Using the [Small Area Income and Poverty Estimates](https://www.census.gov/data/developers/data-sets/Poverty-Statistics.html) dataset, get the poverty rate [(SAEPOVRTALL_PT)](https://api.census.gov/data/timeseries/poverty/saipe/variables/SAEPOVRTALL_PT.html) for every year since 2010 in Los Angeles County, California.

```R
poverty_rate <- getCensus(
	name = "timeseries/poverty/saipe",
	vars = c("NAME", "SAEPOVRTALL_PT"),
	region = "county:037",
	regionin = "state:06",
	time = "from 2010")

poverty_rate

#>    time 	state county NAME 				      SAEPOVRTALL_PT
#> 1  2010  06    037 	 Los Angeles County           17.6
#> 2  2011  06    037    Los Angeles County           18.4
#> 3  2012  06    037    Los Angeles County           19.1
#> 4  2013  06    037    Los Angeles County           19.0
#> 5  2014  06    037    Los Angeles County           18.7
#> 6  2015  06    037    Los Angeles County           16.7
#> 7  2016  06    037    Los Angeles County           16.3
#> 8  2017  06    037    Los Angeles County           14.9
#> 9  2018  06    037    Los Angeles County           14.2
#> 10 2019  06    037    Los Angeles County           13.4
#> 11 2020  06    037    Los Angeles County           13.2
#> 12 2021  06    037    Los Angeles County           14.1
#> 13 2022  06    037    Los Angeles County           13.9
#> 14 2023  06    037    Los Angeles County           13.7

```

Using the 2022 [5-year American Community Survey](https://www.census.gov/data/developers/data-sets/acs-5year.html) Subject Tables dataset, for all Census tracts in Arizona, get the:

* total number of households [(S2801_C01_001E)](https://api.census.gov/data/2022/acs/acs5/subject/variables/S2801_C01_001E.html)
* number of households without an internet subscription [(S2801_C01_019E)](https://api.census.gov/data/2022/acs/acs5/subject/variables/S2801_C01_019E.html)
* percent of households without an internet subscription [(S2801_C02_019E)](https://api.census.gov/data/2022/acs/acs5/subject/variables/S2801_C02_019E.html)
* Census tract name

```R
no_internet <- getCensus(
    name = "acs/acs5/subject",
    vintage = 2023,
    vars = c("S2801_C01_001E", "S2801_C01_019E", "S2801_C02_019E"),
    region = "tract:*",
    regionin = "state:04")
    
head(no_internet)

#>  			state county	tract 	S2801_C01_001E S2801_C01_019E S2801_C02_019E
#>   1    04    001 		942600             441            415           94.1
#>   2    04    001 		942700            1480            989           66.8
#>   3    04    001 		944000            1565            822           52.5
#>   4    04    001 		944100            1488            887           59.6
#>   5    04    001 		944201            1165            663           56.9
#>   6    04    001 		944202            1149            746           64.9
```

## Advanced usage
Users can pass any valid parameters to the APIs using `getCensus()`. The Census Bureau refers to these filterable parameter variables as "predicates".

Using the [Small Area Health Insurance Estimates](https://www.census.gov/data/developers/data-sets/Health-Insurance-Statistics.html), we can use these predicates to get the uninsured rate ([PCTUI_PT](https://api.census.gov/data/timeseries/healthins/sahie/variables/PCTUI_PT.json)) for specific demographic groups, including income group, age group, and race/ethnicity.

```R
# See the values of `IPRCAT`
listCensusMetadata(
	name = "timeseries/healthins/sahie",
	type = "values",
	variable = "IPRCAT")
	
#> 	  code                                 label
#> 	1    0                           All Incomes
#> 	2    1 Less than or Equal to 200% of Poverty
#> 	3    2 Less than or Equal to 250% of Poverty
#> 	4    3 Less than or Equal to 138% of Poverty
#> 	5    4 Less than or Equal to 400% of Poverty
#> 	6    5                  138% to 400% Poverty
	
# See the values of `AGECAT`
listCensusMetadata(
	name = "timeseries/healthins/sahie",
	type = "values",
	variable = "AGECAT")
	
#> 	  code          label
#> 	1    0 Under 65 years
#> 	2    1       18 to 64
#> 	3    2       40 to 64
#> 	4    3       50 to 64
#> 	5    4 Under 19 years
#> 	6    5 21 to 64 years

# Get the uninsured rate over time for for nonelderly adults (AGECAT = 1)
# at 138% to 400% of the federal poverty line (IPRCAT = 5) 
# in Los Angeles County, California
sahie_la <- getCensus(
    name = "timeseries/healthins/sahie",
    vars = c("NAME", "PCTUI_PT"),
    region = "county:037",
    regionin = "state:06",
    time = "from 2012",
    IPRCAT = 5,
    AGECAT = 1)
sahie_la

#>    time state county                   NAME PCTUI_PT IPRCAT AGECAT
#> 1  2012    06    037 Los Angeles County, CA     35.5      5      1
#> 2  2013    06    037 Los Angeles County, CA     34.3      5      1
#> 3  2014    06    037 Los Angeles County, CA     25.0      5      1
#> 4  2015    06    037 Los Angeles County, CA     18.6      5      1
#> 5  2016    06    037 Los Angeles County, CA     16.3      5      1
#> 6  2017    06    037 Los Angeles County, CA     15.5      5      1
#> 7  2018    06    037 Los Angeles County, CA     16.2      5      1
#> 8  2019    06    037 Los Angeles County, CA     18.3      5      1
#> 9  2020    06    037 Los Angeles County, CA     16.7      5      1
#> 10 2021    06    037 Los Angeles County, CA     16.1      5      1
#> 11 2022    06    037 Los Angeles County, CA     15.2      5      1

# Get the uninsured rate for nonelderly adults (AGECAT = 1)
# at 138% to 400% of the federal poverty line (IPRCAT = 5)
# by race and ethnicity for Alabama
sahie_alabama <- getCensus(
    name = "timeseries/healthins/sahie",
    vars = c("NAME", "PCTUI_PT", "RACECAT", "RACE_DESC"), 
    region = "state:01", 
    time = 2022,
    IPRCAT = 5,
    AGECAT = 1)
sahie_alabama

#>   time  state    NAME PCTUI_PT RACECAT                                                                RACE_DESC IPRCAT AGECAT
#> 1 2022   	01 Alabama     14.7       0                                                                All Races      5      1
#> 2 2022   	01 Alabama     12.5       1                                      White alone, not Hispanic or Latino      5      1
#> 3 2022   	01 Alabama     15.2       2                  Black or African American alone, not Hispanic or Latino      5      1
#> 4 2022   	01 Alabama     37.7       3                                            Hispanic or Latino (any race)      5      1
#> 5 2022   	01 Alabama     21.2       4          American Indian and Alaska Native alone, not Hispanic or Latino      5      1
#> 6 2022   	01 Alabama     14.5       5                                      Asian alone, not Hispanic or Latino      5      1
#> 7 2022   	01 Alabama     23.8       6 Native Hawaiian and Other Pacific Islander alone, not Hispanic or Latino      5      1
#> 8 2022   	01 Alabama     16.1       7                                Two or More Races, not Hispanic or Latino      5      1

```

To learn more about using `censusapi`, read the package documentation and articles at  [https://www.hrecht.com/censusapi/.](https://www.hrecht.com/censusapi/)

## Disclaimer
This product uses the Census Bureau Data API but is not endorsed or certified by the Census Bureau.

Please note that this project is released with a [Contributor Code of Conduct](https://github.com/hrecht/censusapi/blob/main/CODE_OF_CONDUCT.md). By participating in this project you agree to abide by its terms.

# censusapi

<!-- badges: start -->
[![CRAN status](https://www.r-pkg.org/badges/version/censusapi)](https://CRAN.R-project.org/package=censusapi)
[![Development version](https://img.shields.io/github/r-package/v/hrecht/censusapi?label=Development%20version&color=yellow)](https://img.shields.io/github/r-package/v/hrecht/censusapi?label=Development%20version&color=yellow)
[![CRAN downloads badge](https://cranlogs.r-pkg.org:443/badges/grand-total/censusapi)](https://cranlogs.r-pkg.org:443/badges/grand-total/censusapi)
[![R-CMD-check](https://github.com/hrecht/censusapi/actions/workflows/R-CMD-check.yaml/badge.svg)](https://github.com/hrecht/censusapi/actions/workflows/R-CMD-check.yaml)
<!-- badges: end -->

`censusapi` is a lightweight package to get data from the U.S. Census Bureau's [APIs](https://www.census.gov/data/developers.html). More than 1,500 API endpoints are available, including data from surveys such as the Decennial Census, American Community Survey, International Trade Datasets, Small Area Health Insurance Estimates and the Economics Indicators Time Series. `getCensus()` lets users retrieves data from any of those datasets using simple, consistent syntax.

The package also includes metadata functions to help users determine [which datasets](https://www.hrecht.com/censusapi/reference/listCensusApis.html) are available and the variable, geography, and other options in [each of them](https://www.hrecht.com/censusapi/reference/listCensusMetadata.html).

## Installation
Get the latest stable release from CRAN: 
```R
install.packages("censusapi")
```

You can also install the latest development version of `censusapi` from Github using `devtools`:
```R
# Install the devtools package if needed
# install.packages("devtools")
devtools::install_github("hrecht/censusapi")
```

## API key setup

The U.S. Census Bureau APIs require using an API key as of May 12, 2026.

You can [sign up online](http://api.census.gov/data/key_signup.html) to receive a key, which will be sent to your provided email address.

If you save the key with the name `CENSUS_KEY` or `CENSUS_API_KEY` in your .Renviron file, `censusapi` will use it by default without any extra work on your part.

To save your API key, within R, run:

```R
# Check to see if you already have a CENSUS_KEY or CENSUS_API_KEY saved
# If so, no further action is needed
get_api_key()

# If not, add your key to your Renviron file
Sys.setenv(CENSUS_KEY=PASTEYOURKEYHERE)

# Reload .Renviron
readRenviron("~/.Renviron")

# Check to see that the expected key is output in your R console
get_api_key()
```

In some instances, like when using a shared computer, you might not want to put your key in your .Renviron. You can always choose to manually set `key = "PASTEYOURKEYHERE"` as an argument in `censusapi` functions if you prefer.

## Basic usage
Using the [Small Area Income and Poverty Estimates](https://www.census.gov/data/developers/data-sets/Poverty-Statistics.html) dataset, get the poverty rate [(SAEPOVRTALL_PT)](https://api.census.gov/data/timeseries/poverty/saipe/variables/SAEPOVRTALL_PT.html) for every year since 2010 in Los Angeles County, California.

```R
poverty_rate <- getCensus(
	name = "timeseries/poverty/saipe",
	vars = c("NAME", "SAEPOVRTALL_PT"),
	region = "county:037",
	regionin = "state:06",
	time = "from 2010")

poverty_rate

#>    time 	state county NAME 				      SAEPOVRTALL_PT
#> 1  2010  06    037 	 Los Angeles County           17.6
#> 2  2011  06    037    Los Angeles County           18.4
#> 3  2012  06    037    Los Angeles County           19.1
#> 4  2013  06    037    Los Angeles County           19.0
#> 5  2014  06    037    Los Angeles County           18.7
#> 6  2015  06    037    Los Angeles County           16.7
#> 7  2016  06    037    Los Angeles County           16.3
#> 8  2017  06    037    Los Angeles County           14.9
#> 9  2018  06    037    Los Angeles County           14.2
#> 10 2019  06    037    Los Angeles County           13.4
#> 11 2020  06    037    Los Angeles County           13.2
#> 12 2021  06    037    Los Angeles County           14.1
#> 13 2022  06    037    Los Angeles County           13.9
#> 14 2023  06    037    Los Angeles County           13.7

```

Using the 2022 [5-year American Community Survey](https://www.census.gov/data/developers/data-sets/acs-5year.html) Subject Tables dataset, for all Census tracts in Arizona, get the:

* total number of households [(S2801_C01_001E)](https://api.census.gov/data/2022/acs/acs5/subject/variables/S2801_C01_001E.html)
* number of households without an internet subscription [(S2801_C01_019E)](https://api.census.gov/data/2022/acs/acs5/subject/variables/S2801_C01_019E.html)
* percent of households without an internet subscription [(S2801_C02_019E)](https://api.census.gov/data/2022/acs/acs5/subject/variables/S2801_C02_019E.html)
* Census tract name

```R
no_internet <- getCensus(
    name = "acs/acs5/subject",
    vintage = 2023,
    vars = c("S2801_C01_001E", "S2801_C01_019E", "S2801_C02_019E"),
    region = "tract:*",
    regionin = "state:04")
    
head(no_internet)

#>  			state county	tract 	S2801_C01_001E S2801_C01_019E S2801_C02_019E
#>   1    04    001 		942600             441            415           94.1
#>   2    04    001 		942700            1480            989           66.8
#>   3    04    001 		944000            1565            822           52.5
#>   4    04    001 		944100            1488            887           59.6
#>   5    04    001 		944201            1165            663           56.9
#>   6    04    001 		944202            1149            746           64.9
```

## Advanced usage
Users can pass any valid parameters to the APIs using `getCensus()`. The Census Bureau refers to these filterable parameter variables as "predicates".

Using the [Small Area Health Insurance Estimates](https://www.census.gov/data/developers/data-sets/Health-Insurance-Statistics.html), we can use these predicates to get the uninsured rate ([PCTUI_PT](https://api.census.gov/data/timeseries/healthins/sahie/variables/PCTUI_PT.json)) for specific demographic groups, including income group, age group, and race/ethnicity.

```R
# See the values of `IPRCAT`
listCensusMetadata(
	name = "timeseries/healthins/sahie",
	type = "values",
	variable = "IPRCAT")
	
#> 	  code                                 label
#> 	1    0                           All Incomes
#> 	2    1 Less than or Equal to 200% of Poverty
#> 	3    2 Less than or Equal to 250% of Poverty
#> 	4    3 Less than or Equal to 138% of Poverty
#> 	5    4 Less than or Equal to 400% of Poverty
#> 	6    5                  138% to 400% Poverty
	
# See the values of `AGECAT`
listCensusMetadata(
	name = "timeseries/healthins/sahie",
	type = "values",
	variable = "AGECAT")
	
#> 	  code          label
#> 	1    0 Under 65 years
#> 	2    1       18 to 64
#> 	3    2       40 to 64
#> 	4    3       50 to 64
#> 	5    4 Under 19 years
#> 	6    5 21 to 64 years

# Get the uninsured rate over time for for nonelderly adults (AGECAT = 1)
# at 138% to 400% of the federal poverty line (IPRCAT = 5) 
# in Los Angeles County, California
sahie_la <- getCensus(
    name = "timeseries/healthins/sahie",
    vars = c("NAME", "PCTUI_PT"),
    region = "county:037",
    regionin = "state:06",
    time = "from 2012",
    IPRCAT = 5,
    AGECAT = 1)
sahie_la

#>    time state county                   NAME PCTUI_PT IPRCAT AGECAT
#> 1  2012    06    037 Los Angeles County, CA     35.5      5      1
#> 2  2013    06    037 Los Angeles County, CA     34.3      5      1
#> 3  2014    06    037 Los Angeles County, CA     25.0      5      1
#> 4  2015    06    037 Los Angeles County, CA     18.6      5      1
#> 5  2016    06    037 Los Angeles County, CA     16.3      5      1
#> 6  2017    06    037 Los Angeles County, CA     15.5      5      1
#> 7  2018    06    037 Los Angeles County, CA     16.2      5      1
#> 8  2019    06    037 Los Angeles County, CA     18.3      5      1
#> 9  2020    06    037 Los Angeles County, CA     16.7      5      1
#> 10 2021    06    037 Los Angeles County, CA     16.1      5      1
#> 11 2022    06    037 Los Angeles County, CA     15.2      5      1

# Get the uninsured rate for nonelderly adults (AGECAT = 1)
# at 138% to 400% of the federal poverty line (IPRCAT = 5)
# by race and ethnicity for Alabama
sahie_alabama <- getCensus(
    name = "timeseries/healthins/sahie",
    vars = c("NAME", "PCTUI_PT", "RACECAT", "RACE_DESC"), 
    region = "state:01", 
    time = 2022,
    IPRCAT = 5,
    AGECAT = 1)
sahie_alabama

#>   time  state    NAME PCTUI_PT RACECAT                                                                RACE_DESC IPRCAT AGECAT
#> 1 2022   	01 Alabama     14.7       0                                                                All Races      5      1
#> 2 2022   	01 Alabama     12.5       1                                      White alone, not Hispanic or Latino      5      1
#> 3 2022   	01 Alabama     15.2       2                  Black or African American alone, not Hispanic or Latino      5      1
#> 4 2022   	01 Alabama     37.7       3                                            Hispanic or Latino (any race)      5      1
#> 5 2022   	01 Alabama     21.2       4          American Indian and Alaska Native alone, not Hispanic or Latino      5      1
#> 6 2022   	01 Alabama     14.5       5                                      Asian alone, not Hispanic or Latino      5      1
#> 7 2022   	01 Alabama     23.8       6 Native Hawaiian and Other Pacific Islander alone, not Hispanic or Latino      5      1
#> 8 2022   	01 Alabama     16.1       7                                Two or More Races, not Hispanic or Latino      5      1

```

To learn more about using `censusapi`, read the package documentation and articles at  [https://www.hrecht.com/censusapi/.](https://www.hrecht.com/censusapi/)

## Disclaimer
This product uses the Census Bureau Data API but is not endorsed or certified by the Census Bureau.

Please note that this project is released with a [Contributor Code of Conduct](https://github.com/hrecht/censusapi/blob/main/CODE_OF_CONDUCT.md). By participating in this project you agree to abide by its terms.

#' Internal function: Get the API response, return a data frame
#'
#' @keywords internal
getFunction <- function(apiurl, name, key, get, region, regionin, time, show_call, convert_variables, year, date, period, monthly, category_code, data_type_code, naics, pscode, naics2012, naics2007, naics2002, naics1997, sic, ...) {

	# Return API's built in error message if invalid call
	apiCheck <- function(req) {
		if (req$status_code==400) {
			error_message <- (gsub("<[^>]*>", "", httr::content(req, as="text")))
			if (error_message == "error: missing 'for' argument") {
				stop("This dataset requires you to specify a geography with the 'region' argument.")
			}
			stop(paste("The Census Bureau returned the following error message:\n", error_message,
								 "\n Your API call was: ", print(req$url)))
		}
		# Some time series don't give error messages, just don't resolve (e.g. SAIPE)
		if (req$status_code==204) stop("204, no content was returned.\nSee ?listCensusMetadata to learn more about valid API options.", call. = FALSE)
		if (identical(httr::content(req, as = "text"), "")) stop(paste("No output to parse. \n Your API call was: ", print(req$url)), call. = FALSE)
	}

	apiParse <- function (req) {
		if (jsonlite::validate(httr::content(req, as="text"))[1] == FALSE) {
			error_message <- (gsub("<[^>]*>", "", httr::content(req, as="text")))
			stop(paste("The Census Bureau returned the following error message:\n", error_message, "\nYour api call was: ", req$url))
		} else {
			# Show call if option is true
			if (show_call == TRUE) {
				print(paste("Your successful api call was: ", req$url))
				print("For more information, visit the documentation at https://www.hrecht.com/censusapi/")
			}
			raw <- jsonlite::fromJSON(httr::content(req, as = "text"))
		}
	}

	# Function to clean up column names - particularly ones with periods in them
	cleanColnames <- function(dt) {
		# No trailing punct
		colnames(dt) <- gsub("\\.[[:punct:]]*$", "", colnames(dt))
		# All punctuation becomes underscore
		colnames(dt) <- gsub("[[:punct:]]", "_", colnames(dt))
		# Get rid of repeat underscores
		colnames(dt) <- gsub("(_)\\1+", "\\1", colnames(dt))
		return(dt)
	}

	responseFormat <- function(raw) {
		# Make first row the header
		colnames(raw) <- raw[1, ]
		df <- data.frame(raw)
		df <- df[-1,]
		df <- cleanColnames(df)

		# Make all columns character - they already are from the Census but just in
		# case the Census does wonky things
		df[] <- lapply(df, as.character)

		if (convert_variables == TRUE) {
			# If these are part of the variable name, keep as string
			string_col_parts_list <- c("_TTL", "_NAME", "NAICS", "FAGE4", "LABEL",
																 "_DESC", "CAT", "UNIT_QY", "_FLAG",
																 "DISTRICT", "EMPSZES", "POPGROUP")

			# Collapse into a | delimited string for grepl
			collapse_col_parts <- function(parts) {
				collapsed <- paste0(parts, collapse = "|")
				return(collapsed)
			}
			common_string_cols <- collapse_col_parts(string_col_parts_list)

			# Geography variables - exact matches only
			geos_list <- c("GEO_ID", "GEOID", "GEOID1", "GEOID2", "GEOCOMP",
										 "SUMLEVEL", "GEOTYPE",  "GEONAME", "GEOVARIANT",

										 # Top-level geographies
										 "NATION", "US", "DIVISION", "REGION", "LSAD_NAME",

										 # Summary levels - but not ACS Flows SUMLEV1 and SUMLEV2 ints
										 "SUMLEVEL", "SUMMARY_LVL",

										 # States
										 "STATE", "ST", "STNAME", "STATE_OR_PART",

										 # Counties
										 "COUNTY",  "CTY_CODE", "CTY_NAME", "CTYNAME", "EEOCOUNTY",
										 "COUSUB", "COUNTY1", "COUNTY2", "COUNTY_OR_PART",
										 "COUNTY_SUBDIVISION", "COUNTY_SUBDIVISION_OR_PART",
										 "COUNTYSET",

										 # Tracts
										 "TRACT", "TRACT_OR_PART",

										 # Places and cities
										 "PLACE", "PLACEREM", "CONCITY", "CONSCITY", "PRINCITY", "SUBMCD",
										 "PRINCIPAL_CITY_OR_PART", "PRINCIPAL_CITY", "PLACE_REMAINDER_OR_PART",
										 "PLACE_OR_PART", "CONSOLIDATED_CITY", "CONSOLIDATED_CITY_OR_PART",
										 "PLACE_BALANCE_OR_PART", "PLACE_REMAINDER",

										 # PUMAs
										 "PUMA", "PUMA5", "MIGPUMA", "POWPUMA",
										 "PUBLIC_USE_MICRODATA_AREA",

										 # Blocks
										 "BH", "BLKGRP", "BLOCK", "BLOCK_GROUP", "GIDBG",
										 "BLOCK_GROUP_OR_PART",

										 # AIAN geographies
										 "AIANHH", "AIARO", "AIHHTL", "AIRES", "ANRC", "TTRACT",
										 "TBLKGRP", "TRIBALBG", "TRIBALCT", "TRIBALSUB", "TRISUBREM",
										 "AMERICAN_INDIAN_AREA_ALASKA_NATIVE_AREA_HAWAIIAN_HOME_LAND",
										 "ALASKA_NATIVE_REGIONAL_CORPORATION",
										 "AMERICAN_INDIAN_AREA_ALASKA_NATIVE_AREA_HAWAIIAN_HOME_LAND_OR_PART",
										 "TRIBAL_SUBDIVISION_REMAINDER_OR_PART", "TRIBAL_CENSUS_TRACT_OR_PART",
										 "AMERICAN_INDIAN_AREA_ALASKA_NATIVE_AREA_RESERVATION_OR_STATISTICAL_ENTITY_ONLY",
										 "AMERICAN_INDIAN_AREA_OFF_RESERVATION_TRUST_LAND_ONLY_HAWAIIAN_HOME_LAND",
										 "TRIBAL_CENSUS_TRACT",
										 "AMERICAN_INDIAN_AREA_OFF_RESERVATION_TRUST_LAND_ONLY_HAWAIIAN_HOME_LAND_OR_PART",
										 "AMERICAN_INDIAN_AREA_ALASKA_NATIVE_AREA_RESERVATION_OR_STATISTICAL_ENTITY_ONLY_OR_PART",
										 "AMERICAN_INDIAN_TRIBAL_SUBDIVISION",
										 "TRIBAL_BLOCK_GROUP_OR_PART", "TRIBAL_SUBDIVISION_REMAINDER",
										 "AMERICAN_INDIAN_TRIBAL_SUBDIVISION_OR_PART",
										 "TRIBAL_BLOCK_GROUP",
										 "ALASKA_NATIVE_REGIONAL_CORPORATION_OR_PART",

										 # Metro areas
										 "CSA", "MSA", "CBSA", "METDIV", "MSACMSA",
										 "METROPOLITAN_DIVISION",
										 "METROPOLITAN_STATISTICAL_AREA_MICROPOLITAN_STATISTICAL_AREA",
										 "COMBINED_STATISTICAL_AREA",
										 "METROPOLITAN_STATISTICAL_AREA_MICROPOLITAN_STATISTICAL_AREA_OR_PART",
										 "COMBINED_STATISTICAL_AREA_OR_PART",
										 "METROPOLITAN_DIVISION_OR_PART",
										 "CONSOLIDATED_METROPOLITAN_STATISTICAL_AREA",
										 "PRIMARY_METROPOLITAN_STATISTICAL_AREA",
										 "CONSOLIDATED_METROPOLITAN_STATISTICAL_AREA_OR_PART",
										 "PRIMARY_METROPOLITAN_STATISTICAL_AREA_OR_PART",
										 "METROPOLITAN_STATISTICAL_AREAS",
										 "MICROPOLITAN_STATISTICAL_AREA",

										 # Congressional districts
										 "CD", "CD106", "CD107", "CD108", "CD109", "CD110", "CD111",
										 "CD112", "CD113", "CD114", "CD115", "CD116", "CDCURR",
										 "CONGRESSIONAL_DISTRICT", "CONGRESSIONAL_DISTRICT_OR_PART",
										 # Future proof congress for a while
										 "CD117", "CD118", "CD119",

										 # State legislative districts
										 "SLDL", "SLDU", "STATE_LEGISLATIVE_DISTRICT_LOWER_CHAMBER",
										 "STATE_LEGISLATIVE_DISTRICT_UPPER_CHAMBER",
										 "STATE_LEGISLATIVE_DISTRICT_LOWER_CHAMBER_OR_PART",
										 "STATE_LEGISLATIVE_DISTRICT_UPPER_CHAMBER_OR_PART",

										 # NECTAs and related
										 "CNECTA", "NECTA", "NECTADIV", "NECMA", "NECTA_DIVISION",
										 "NEW_ENGLAND_CITY_AND_TOWN_AREA",
										 "COMBINED_NEW_ENGLAND_CITY_AND_TOWN_AREA",
										 "NEW_ENGLAND_CITY_AND_TOWN_AREA_OR_PART",
										 "COMBINED_NEW_ENGLAND_CITY_AND_TOWN_AREA_OR_PART",
										 "NECTA_DIVISION_OR_PART",
										 "NEW_ENGLAND_COUNTY_METROPOLITAN_AREA",
										 "NEW_ENGLAND_COUNTY_METROPOLITAN_AREA_OR_PART",

										 # School districts
										 "SDELM", "SDSEC", "SDUNI", "SCHOOL_DISTRICT_ELEMENTARY",
										 "SCHOOL_DISTRICT_SECONDARY", "SCHOOL_DISTRICT_UNIFIED",
										 "SCHOOL_DISTRICT_ELEMENTARY_OR_PART",
										 "SCHOOL_DISTRICT_SECONDARY_OR_PART",
										 "SCHOOL_DISTRICT_UNIFIED_OR_PART",
										 "SCHOOL_DISTRICT_ADMINISTRATIVE_AREA",

										 # Sub-Minor Civil Division
										 "SUBMCD", "SUBMINOR_CIVIL_DIVISION",
										 "SUBMINOR_CIVIL_DIVISION_OR_PART",

										 # ZCTAs
										 "ZIPCODE", "ZCTA", "ZCTA5", "ZCTA3", "ZIP_CODE",
										 "ZIP_CODE_TABULATION_AREA",
										 "ZIP_CODE_TABULATION_AREA_OR_PART",
										 "ZIP_CODE_TABULATION_AREA_3_DIGIT",
										 "ZIP_CODE_TABULATION_AREA_3_DIGIT_OR_PART",

										 # Urban area, Urban/rural
										 "UA", "UR", "URBAN_AREA", "URBAN_RURAL", "URBAN_AREA_OR_PART",

										 # Voting district
										 "VTD", "VOTING_DISTRICT",
										 "VOTING_DISTRICT_OR_PART",

										 # Imports and exports geographies
										 "USITC", "USITCHISTORY", "USITCREG", "CUSTDISTRICT", "DIST_NAME",
										 "PORT", "WORLD",
										 "USITC_STANDARD_COUNTRIES_AND_AREAS",
										 "USITC_STANDARD_INTERNATIONAL_REGIONS",
										 "USITC_STANDARD_HISTORICAL_COUNTRIES_AND_AREAS",

										 # Various Economic APIs geographies
										 "CFSAREA", "COMMREG", "ECPLACE",
										 "CFS_AREA_OR_PART", "COMMERCIAL_REGION",

										 # 2020 Decennial
										 "ESTATE",

										 # Random rarely-used geographies
										 "ESTPLACE", "EUCOUSUB", "EUPB", "GENC",
										 "WORKFORCE_INVESTMENT_AREA",
										 "GENC_STANDARD_COUNTRIES_AND_AREAS",
										 "PUERTO_RICO_PLANNING_AREA",

										 # CPS microdata
										 "GESTFIPS", "GTCO", "HG_FIPS",

										 # SIPP microdata
										 "TFIPSST")

			# Microdata APIs - don't convert string identifier variables that appear
			# in >5 endpoints as strings only or nearly always as strings
			if (grepl("cps/|pums|sipp", name, ignore.case = T)) {

				common_string_cols <- collapse_col_parts(
					c( #SIPP PUMS
						"SSUID",
						# CPS PUMS
						"HRHHID", "HRSAMPLE", "HRSERSUF", "GECMSASZ", "H_ID", "H_ID_PL",
						"H_IDNUM", "OCCURNUM", "QSTNUM",
						# ACS PUMS
						"RT", "SERIALNO", "CONCAT_ID", "RECORD_TYPE", "SOCP",
						"OCCP10", "OCCP02", "OCCP12",
					common_string_cols))
			}

			# For ACS data, also keep as strings ACS annotation variables
			# ending in MA or EA or SS
			if (grepl("acs/acs", name, ignore.case = T) &
					!(grepl("pums", name, ignore.case = T))) {
				common_string_cols <- collapse_col_parts(
					c("MA", "EA", "SS",
						common_string_cols))
			}

			# Columns that contain string parts in the name stay as strings
			string_part_cols <- grep(common_string_cols, names(df), value = TRUE, ignore.case = T)

			# Columns that match geos_list exactly stay as strings (other than case sensitivity)
			geo_cols <- names(df)[toupper(names(df)) %in% geos_list]

			# Identify all the geo/string columns to keep as strings
			string_cols <- c(geo_cols, string_part_cols)

			# For columns that aren't explicitly defined here as strings, convert them to numeric
			# If they are actually all numbers
			for(col in setdiff(names(df), string_cols)) {
				df[,col] <- utils::type.convert(df[,col],
																				as.is = TRUE,
																				# Some returned data contains messy NAs, account for them
																				na.strings = c(NA, "NULL", "N/A", "NA"))
				#}

			}
		}
		row.names(df) <- NULL

		return(df)
	}

	# Assemble call
	req <- httr::GET(apiurl, query = list(key = key, get = get, "for" = region, "in" = regionin, category_code = category_code, data_type_code = data_type_code, time = time, YEAR = year, DATE = date, PERIOD = period, MONTHLY = monthly, NAICS=naics, PSCODE=pscode, NAICS2012 = naics2012, NAICS2007 = naics2007, NAICS2002 = naics2002, NAICS1997 = naics1997, SIC = sic, ...))

	# Check the API call for a valid response
	apiCheck(req)

	# If check didn't fail, parse the content
	raw <- apiParse(req)

	# Format the response into a nice data frame
	df <- responseFormat(raw)
}

#' Retrieve Census data from a given API
#'
#' @param name The programmatic name of your dataset, e.g.
#'   "timeseries/poverty/saipe" or "acs/acs5". Use listCensusApis() to see valid
#'   dataset names. Required.
#' @param vintage Vintage (year) of dataset, e.g. 2014. Not required for
#'   timeseries APIs.
#' @param vars List of variables to get. Required.
#' @param region Geography to get.
#' @param regionin Optional hierarchical geography to limit region.
#' @param key A Census API key, obtained at
#'   <https://api.census.gov/data/key_signup.html>. If you have a `CENSUS_KEY` or
#'   `CENSUS_API_KEY` stored in your .Renviron file, getCensus() will
#'   automatically use that key.
#' @param time Time period of data to get. Required for most timeseries APIs.
#' @param show_call Display the underlying API call that was sent to the Census
#'   Bureau. Default is FALSE.
#' @param convert_variables Convert columns that are likely numbers into numeric
#'   data. Default is TRUE. If false, all columns will be characters, which is
#'   the type returned by the Census Bureau.
#' @param
#' year,date,period,monthly,category_code,data_type_code,naics,pscode,naics2012,naics2007,naics2002,naics1997,sic
#' Optional arguments used in some timeseries data APIs.
#' @param ... Other valid arguments to pass to the Census API. Note: the APIs
#'   are case sensitive.
#' @returns A data frame with results from the specified U.S. Census Bureau dataset.
#' @examplesIf has_api_key()
#' # Get total population and median household income for Census places
#' # (cities, towns, villages) in a single state from the 5-year American Community Survey.
#' acs_simple <- getCensus(
#'   name = "acs/acs5",
#'   vintage = 2022,
#'   vars = c("NAME", "B01001_001E", "B19013_001E"),
#'   region = "place:*",
#'   regionin = "state:01")
#' head(acs_simple)
#'
#' # Get all data from the B08301 variable group, "Means of Transportation to Work."
#' # This returns estimates as well as margins of error and annotation flags.
#' acs_group <- getCensus(
#'   name = "acs/acs5",
#'   vintage = 2022,
#'   vars = "group(B08301)",
#'   region = "state:*")
#' head(acs_group)
#'
#' # Retreive 2020 Decennial Census block group data within a specific Census tract,
#' # using the regionin argument to precisely specify the Census tract, county,
#' # and state.
#' decennial_block_group <- getCensus(
#' 	name = "dec/dhc",
#' 	vintage = 2020,
#' 	vars = c("NAME", "P1_001N"),
#' 	region = "block group:*",
#' 	regionin = "state:36+county:027+tract:220300")
#' head(decennial_block_group)
#'
#' # Get poverty rates for children and for people of all ages beginning in 2000 using the
#' # Small Area Income and Poverty Estimates API
#' saipe <- getCensus(
#'   name = "timeseries/poverty/saipe",
#'   vars = c("NAME", "SAEPOVRT0_17_PT", "SAEPOVRTALL_PT"),
#'   region = "state:01",
#'   time = "from 2000")
#' head(saipe)
#'
#' # Get the number of employees and number of establishments in the construction sector,
#' # NAICS2017 code 23, using the County Business Patterns API
#' cbp <- getCensus(
#' 	name = "cbp",
#' 	vintage = 2021,
#' 	vars = c("EMP", "ESTAB", "NAICS2017_LABEL"),
#' 	region = "county:*",
#' 	NAICS2017 = 23)
#' head(cbp)
#'
#' @export
getCensus <-
	function(name,
					 vintage = NULL,
					 key = NULL,
					 vars,
					 region = NULL,
					 regionin = NULL,
					 time = NULL,
					 show_call = FALSE,
					 convert_variables = TRUE,
					 year = NULL,
					 date = NULL,
					 period = NULL,
					 monthly = NULL,
					 category_code = NULL,
					 data_type_code = NULL,
					 naics = NULL,
					 pscode = NULL,
					 naics2012 = NULL,
					 naics2007 = NULL,
					 naics2002 = NULL,
					 naics1997 = NULL,
					 sic = NULL,
					 ...) {

	constructURL <- function(name, vintage) {
		if (is.null(vintage)) {
			apiurl <- paste("https://api.census.gov/data", name, sep="/")
		} else {
			apiurl <- paste("https://api.census.gov/data", vintage, name, sep="/")
		}

		# Handle messy urls
		lastchar <- substr(apiurl, nchar(apiurl), nchar(apiurl))
		if (lastchar=="?" | lastchar=="/") {
			apiurl <- substr(apiurl, 1, nchar(apiurl)-1)
		}
		apiurl
	}

	# Check for key in function args and environment, stop if one is not provided
	key <- enforce_key(key)

	apiurl <- constructURL(name, vintage)

	# Census API max vars per call = 50
	# Splitting function based on work by Nicholas Nagle, https://rpubs.com/nnnagle/19337
	if(length(vars)>50){
		# Split vars into list
		vars <- split(vars, ceiling(seq_along(vars)/50))
		get <- lapply(vars, function(x) paste(x, sep='', collapse=","))
		data <- lapply(get, function(x) getFunction(apiurl, name, key, x, region, regionin, time, show_call, convert_variables, year, date, period, monthly, category_code, data_type_code, naics, pscode, naics2012, naics2007, naics2002, naics1997, sic, ...))

		data <- Reduce(function(x, y) merge(x, y, all = TRUE, sort = FALSE), data)

	} else {
		get <- paste(vars, sep='', collapse=',')
		data <- getFunction(apiurl, name, key, get, region, regionin, time, show_call, convert_variables, year, date, period, monthly, category_code, data_type_code, naics, pscode, naics2012, naics2007, naics2002, naics1997, sic, ...)
	}

	# If there are any duplicate columns (ie if you put a variable in vars twice) remove the duplicates
	data <- data[, !duplicated(colnames(data))]

	# Reorder columns so that lowercase column names (geographies) are first
	data <- data[,c(which(grepl("[a-z]", colnames(data))), which(!grepl("[a-z]", colnames(data))))]
	return(data)
}

#' Retrieve a Census API key stored the .Renivron file
#'
#' @family helpers
#' @returns A CENSUS_KEY or CENSUS_API_KEY string stored in the user's .Renviron.
#'   file, or a warning message printed once per R session if none is found.
#'
#' @examples
#' \dontrun{
#' get_api_key()
#' }
#'
#' @export
get_api_key <- function() {
	if (Sys.getenv("CENSUS_KEY") != "") {
		key <- Sys.getenv("CENSUS_KEY")
		key
	} else if (Sys.getenv("CENSUS_API_KEY") != "") {
		key <- Sys.getenv("CENSUS_API_KEY")
		key
	} else {
		rlang::warn("You do not have a stored Census API key.\nRegister for an API key at https://api.census.gov/data/key_signup.html\nand store it in your Renviron file as CENSUS_KEY or CENSUS_API_KEY.\nLearn more at https://www.hrecht.com/censusapi/articles/getting-started.html.",
								.frequency = "once", .frequency_id = "api_key")
		key <- NULL
		key
	}
}
#' Is there a saved Census API key in the .Renivron file?
#'
#' @family helpers
#' @returns TRUE or FALSE.
#' @examples
#' has_api_key()
#'
#' @export
has_api_key <- function() {
	if (!is.null(get_api_key())) {
		TRUE
	} else {
		FALSE
	}
}

# Enforce using an API key
#'
#' @param key an API key
#' @returns an API key from a provided value or .Renviron
#'
#' @noRd

enforce_key <- function(key) {
	# If the `key` argument in the function isn't used then check the .Renviron
	if (is.null(key)) {
		key <- get_api_key()

		# If no key found, stop and throw a message
		if (is.null(key)) {
			stop("The U.S. Census Bureau requires an API key to access data.\nRegister for an API key at https://api.census.gov/data/key_signup.html\nand store it in your Renviron file as CENSUS_KEY or CENSUS_API_KEY,\nor use the `key` argument. Learn more at\nhttps://www.hrecht.com/censusapi/articles/getting-started.html.")
		}
	}

	# Return the specified or .Renviron key for use in the function
	return(key)
}

#' List of state fips codes - 50 states plus DC
#'
#' Some small geographies in some Census APIs can only be used under a state hierarchy.
#' This is a list of fips codes that may be looped over to retrieve data for all states.
#' @format A list of fips codes for 50 states and the District of Columbia.
#' @examples
#' fips
"fips"

#' Get general information about available datasets
#'
#' Scrapes <https://api.census.gov/data.json> and returns a dataframe that
#' includes columns for dataset title, description, name, vintage, url, dataset
#' type, and other useful fields.
#'
#' @family metadata
#' @param name Optional complete or partial API dataset programmatic name. For
#'   example, "acs", "acs/acs5", "acs/acs5/subject". If using a partial name,
#'   this needs to be the left-most part of the dataset name before `/`, e.g.
#'   "timeseries/eits" or "dec" or "acs/acs5".
#' @param vintage Optional vintage (year) of dataset.
#' @param key A Census API key, obtained at
#'   <https://api.census.gov/data/key_signup.html>. If you have a `CENSUS_KEY` or
#'   `CENSUS_API_KEY` stored in your .Renviron file, getCensus() will
#'   automatically use that key.
#' @returns A data frame with the following columns:
#' * title: Short written description of the dataset.
#' * name: Programmatic name of the dataset.
#' * vintage: Year of the survey, for use with microdata and aggregate datasets.
#' * type: Dataset type, which is either "Aggregate", "Microdata", or "Timeseries".
#' * temporal: Time period of the dataset. Warning: not always documented.
#' * spatial: Spatial region of the dataset. Warning: not always documented.
#' * url: Base URL of the dataset endpoint.
#' * modified: Date last modified. Warning: sometimes out of date.
#' * description: Long written description of the dataset.
#' * contact: Email address for specific questions about the Census Bureau survey.
#' @examplesIf has_api_key()
#' # Get information about every dataset available in the APIs
#' apis <- listCensusApis()
#' head(apis)
#'
#' # Get information about all vintage 2022 datasets
#' apis_2022 <- listCensusApis(vintage = 2022)
#' head(apis_2022)
#'
#' # Get information about all timeseries datasets
#' apis_timeseries <- listCensusApis(name = "timeseries")
#' head(apis_timeseries)
#'
#' # Get information about 2020 Decennial Census datasets
#' apis_decennial_2020 <- listCensusApis(name = "dec", vintage = 2020)
#' head(apis_decennial_2020)
#'
#' # Get information about one particular dataset
#' api_sahie <- listCensusApis(name = "timeseries/healthins/sahie")
#' head(api_sahie)
#'
#' @export
listCensusApis <- function(name = NULL,
													 vintage = NULL,
													 key = NULL) {
	constructURL <- function(name, vintage) {
			# Get data.json
		if (is.null(name) & is.null(vintage)) {
			u <- "https://api.census.gov/data.json"
		} else if (is.null(vintage) & !is.null(name)) {
			u <- paste0("https://api.census.gov/data/", name,	".json")
		} else if (is.null(name) & !is.null(vintage)) {
			u <- paste0("https://api.census.gov/data/", vintage, ".json")
		} else if (!is.null(name) & !is.null(vintage)) {
			u <- paste0("https://api.census.gov/data/", vintage, "/", name, ".json")
		}
	}

	# Check for key in function args and environment, stop if one is not provided
	key <- enforce_key(key)

	# Return API's built in error message if invalid call
	apiCheck <- function(req) {
		if (!(req$status_code %in% c(200, 201, 202))) {
			if (req$status_code == 404) {
				stop(paste("Invalid metadata request, (404) not found.",
									 "\n Your API call was: ", print(req$url)), call. = FALSE)
			} else if (req$status_code==400) {
				stop(paste("The Census Bureau returned the following error message:\n", req$error_message,
									 "\n Your API call was: ", print(req$url)))
			} else if (req$status_code==204) {
				stop(paste("204, no content was returned. \n Your API call was: ", print(req$url)), call. = FALSE)
			} else if (identical(httr::content(req, as = "text"), "")) {
				stop(paste("No output to parse. \n Your API call was: ", print(req$url)), call. = FALSE)
			}
		}
	}

	apiParse <- function (req) {
		if (jsonlite::validate(httr::content(req, as="text"))[1] == FALSE) {
			error_message <- (gsub("<[^>]*>", "", httr::content(req, as="text")))
			stop(paste("The Census Bureau returned the following error message:\n", error_message, "\nYour api call was: ", req$url))
		} else {
			raw <- jsonlite::fromJSON(httr::content(req, as = "text"))
		}
	}

	u <- constructURL(name = name, vintage = vintage)
	req <- httr::GET(u, query = list(key = key))
	# Check the API call for a valid response
	apiCheck(req)

	# If check didn't fail, parse the content
	raw <- apiParse(req)

	#raw <- jsonlite::fromJSON(u)
	datasets <- jsonlite::flatten(raw$dataset)

	# Format variable names and values
	colnames(datasets) <- gsub("c_", "", colnames(datasets))
	datasets$name <- apply(datasets, 1, function(x) paste(x$dataset, collapse = "/"))
	datasets$url <- apply(datasets, 1, function(x) x$distribution$accessURL)

	names(datasets)[names(datasets) == "contactPoint.hasEmail"] <- "contact"

	# Add a dataset type variable built from binary variables
	# If requesting a subset of datasets it won't have all of these fields so assign
	# values one by one
	datasets$type <- NA
	if ("isMicrodata" %in% colnames(datasets)) {
		datasets$type <- ifelse(datasets$isMicrodata %in% TRUE, "Microdata", datasets$type)
	}
	if ("isAggregate" %in% colnames(datasets)) {
		datasets$type <- ifelse(datasets$isAggregate %in% TRUE, "Aggregate", datasets$type)
	}
	if ("isTimeseries" %in% colnames(datasets)) {
		datasets$type <- ifelse(datasets$isTimeseries %in% TRUE, "Timeseries", datasets$type)
	}

	# Keep only valuable columns - many are not useful (empty or the same for all datasets)
	if ("vintage" %in% colnames(datasets)) {
		dt <- datasets[, c("title", "name", "vintage", "type", "temporal",
											 "spatial", "url", "modified", "description", "contact")]

		# Give some logic to the row ordering
		dt <- dt[order(-dt$vintage, dt$name),]
	} else {
		dt <- datasets[, c("title", "name", "type", "temporal", "spatial",
											 "url", "modified", "description", "contact")]
		dt <- dt[order(dt$name),]
	}
	dt$contact <- gsub("mailto:", "", dt$contact)

	rownames(dt) <- NULL
	return(dt)
}

#' Get metadata about a specified API endpoint
#'
#' Get information about a Census Bureau API dataset, including its available
#' variables, geographies, variable groups, and value labels
#'
#' @family metadata
#' @param name API programmatic name - e.g. acs/acs5. Use `listCensusApis()` to
#'   see valid dataset names.
#' @param vintage Vintage (year) of dataset. Not required for timeseries APIs.
#' @param key A Census API key, obtained at
#'   <https://api.census.gov/data/key_signup.html>. If you have a `CENSUS_KEY` or
#'   `CENSUS_API_KEY` stored in your .Renviron file, getCensus() will
#'   automatically use that key.
#' @param type Type of metadata to return. Options are:
#' * "variables" (default) - list of variable names and descriptions
#'   for the dataset.
#' * "geographies" - available geographies.
#' * "groups" - available variable groups. Only available
#'   for some datasets.
#' * "values" - encoded value labels for a given variable. Pair with
#'   "variable_name". Only available for some datasets.
#' @param group An optional variable group code, used to return metadata for a
#'   specific group of variables only. Variable groups are not used for all
#'   APIs.
#' @param variable_name A name of a specific variable used to return value
#'   labels for that variable. Value labels are not used for all APIs.
#' @param include_values Use with `type = "variables"`. Include value metadata
#'   for all variables in a dataset if value metadata exists. Default is
#'   "FALSE".
#' @returns A data frame with metadata about the specified API endpoint.
#' @examplesIf has_api_key()
#' # type: variables # List the variables available in the Small Area
#' # Health Insurance Estimates.
#' variables <- listCensusMetadata(
#'   name = "timeseries/healthins/sahie", type = "variables")
#' head(variables)
#'
#' # type: variables for a single variable group
#' # List the variables that are included in the B17020 group in the
#' # 5-year American Community Survey.
#' variable_group <- listCensusMetadata(
#'   name = "acs/acs5", vintage = 2022,
#'   type = "variables", group = "B17020")
#' head(variable_group)
#'
#' # type: variables, with value labels
#' # Create a data dictionary with all variable names and encoded values
#' # for a microdata API.
#' variable_values <- listCensusMetadata(
#'   name = "cps/voting/nov",
#'   vintage = 2020,
#'   type = "variables",
#'   include_values = TRUE)
#' head(variable_values)
#'
#' # type: geographies
#' # List the geographies available in the 5-year American Community Survey.
#' geographies <- listCensusMetadata(
#'   name = "acs/acs5",
#'   vintage = 2022,
#'   type = "geographies")
#' head(geographies)
#'
#' # type: groups
#' # List the variable groups available in the 5-year American
#' # Community Survey.
#' groups <- listCensusMetadata(
#'   name = "acs/acs5",
#'   vintage = 2022,
#'   type = "groups")
#' head(groups)
#'
#' # type: values for a single variable
#' # List the value labels of the NAICS2017 variable in the County
#' # Business Patterns dataset.
#' naics_values <- listCensusMetadata(
#'   name = "cbp",
#'   vintage = 2021,
#'   type = "values",
#'   variable = "NAICS2017")
#' head(naics_values)
#'
#' @export
listCensusMetadata <-
	function(name,
					 vintage = NULL,
					 key = NULL,
					 type = "variables",
					 group = NULL,
					 variable_name = NULL,
					 include_values = FALSE) {

		constructURL <- function(name, vintage) {
			if (is.null(vintage)) {
				apiurl <- paste("https://api.census.gov/data", name, sep="/")
			} else {
				apiurl <- paste("https://api.census.gov/data", vintage, name, sep="/")
			}

			# Handle messy urls
			lastchar <- substr(apiurl, nchar(apiurl), nchar(apiurl))
			if (lastchar=="?" | lastchar=="/") {
				apiurl <- substr(apiurl, 1, nchar(apiurl)-1)
			}
			apiurl
		}

		# Return API's built in error message if invalid call
		apiCheck <- function(req) {
			if (!(req$status_code %in% c(200, 201, 202))) {
				if (req$status_code == 404) {
					stop(paste("Invalid metadata request, (404) not found.",
										 "\n Your API call was: ", print(req$url)), call. = FALSE)
				} else if (req$status_code==400) {
					stop(paste("The Census Bureau returned the following error message:\n", req$error_message,
										 "\n Your API call was: ", print(req$url)))
				} else if (req$status_code==204) {
					stop(paste("204, no content was returned. \n Your API call was: ", print(req$url)), call. = FALSE)
				} else if (identical(httr::content(req, as = "text"), "")) {
					stop(paste("No output to parse. \n Your API call was: ", print(req$url)), call. = FALSE)
				}
			}
		}

		apiParse <- function (req) {
			if (jsonlite::validate(httr::content(req, as="text"))[1] == FALSE) {
				error_message <- (gsub("<[^>]*>", "", httr::content(req, as="text")))
				stop(paste("The Census Bureau returned the following error message:\n", error_message, "\nYour api call was: ", req$url))
			} else {
				raw <- jsonlite::fromJSON(httr::content(req, as = "text"))
			}
		}

		# Check for key in function args and environment, stop if one is not provided
		key <- enforce_key(key)

		apiurl <- constructURL(name, vintage)

		if (type %in% c("variables")) {
			# Too nested and irregular for automatic conversion

			if (!is.null(group)) {
				u <- paste(apiurl, "/groups/", group, ".json", sep="")

				req <- httr::GET(u, query = list(key = key))
				# Check the API call for a valid response
				apiCheck(req)

				# If check didn't fail, parse the content
				raw <- apiParse(req)

				cols <- unique(unlist(lapply(raw$variables, names)))
				makeDf <- function(d) {
					df <- data.frame(d)
					df[, setdiff(cols, names(df))] <- NA
					return(df)
				}
				dts <- lapply(raw$variables, function(x) {makeDf(x)})

			} else {
				u <- paste(apiurl, "variables.json", sep="/")
				req <- httr::GET(u, query = list(key = key))
				# Check the API call for a valid response
				apiCheck(req)

				# If check didn't fail, parse the content
				raw <- apiParse(req)
				# JSON of variables has irregular structure that gets standardized in the HTML view
				# Particularly the datetime filed used in some APIs
				# Generally, predicateOnly = parameter, exclude predicateOnly (parameters)

				# Manual fill with NAs as needed to avoid adding a dplyr::bind_rows or similar dependency

				# Get the list of possible column names
				cols <- unique(unlist(lapply(raw$variables, names)))

				# Remove invalid dashes in variable names - problem present in Microdata APIs
				cols <- gsub("-", "_", cols)

				if (include_values == FALSE | !("values" %in% cols)) {

					# Warn the user if they've asked for value labels but none are present
					if (include_values == TRUE & !("values" %in% cols)) {
						warning("You've set `include_values` to TRUE but this dataset does not contain variable values. Variable values will not be returned")
					}
					cols <- cols[!(cols %in% c("validValues", "values", "datetime"))]

					# Remove attributes that have nested lists
					makeDf <- function(d) {
						names(d) <- gsub("-", "_", names(d))
						if ("validValues" %in% names(d)) {
							d$validValues <- NULL
						}
						if ("values" %in% names(d)) {
							d$values <- NULL
						}
						if ("datetime" %in% names(d)) {
							d$datetime <- NULL
						}
						df <- data.frame(d)

						df[, setdiff(cols, names(df))] <- NA
						return(df)
					}

					dts <- lapply(raw$variables, makeDf)

				} else if (include_values == TRUE) {

			  	# Prepare for value code and label if the value metadata is present
					if ("values" %in% cols) {
						# print("VALUES ARE PRESENT")
						cols <- c(cols, "values_code", "values_label")
						cols <- cols[cols != "values"]
					}

					makeDf <- function(d) {
						names(d) <- gsub("-", "_", names(d))

						# As of right now, not using the "range" metadata in some of the microdata,
						# only item labels
						if ("values" %in% names(d) & "item" %in% names(d$values)) {
							# print(("YES VALUES META")
							# Make data frame of value labels
							temp_vals <- utils::stack(d$values$item)

							# Column cleaning
							colnames(temp_vals) <- c("label", "code")
							temp_vals <- temp_vals[, c("code", "label")]
							# Use character, not factor
							temp_vals$code <- as.character(temp_vals$code)

							# Assign back to parent
							d$values <- temp_vals

							df <- as.data.frame(d)
							names(df) <- gsub("\\.", "_", names(df))

						} else {
							# print("NO VALUES META")
							# Set values to null in case it exists but without `item` labels
							d$values <- NULL

							df <- as.data.frame(d)
						}

						df[, setdiff(cols, names(df))] <- NA
						return(df)
					}

					dts <- lapply(raw$variables, makeDf)
				}
			}

			temp <- Filter(is.data.frame, dts)
			dt <- do.call(rbind, temp)

			# Clean up row names aka variable names
			dt <- cbind(name = row.names(dt), dt)
			row.names(dt) <- NULL
			# If there are periods in the name field from concatenated numbers, remove
			dt$name <- gsub("\\..*", "", dt$name)
			dt[] <- lapply(dt, as.character)


		} else if (type %in% c("geographies", "geography")) {
			u <- paste(apiurl, "geography.json", sep="/")
			req <- httr::GET(u, query = list(key = key))
			# Check the API call for a valid response
			apiCheck(req)

			# If check didn't fail, parse the content
			raw <- apiParse(req)
			dt <- raw$fips
		} else if (type %in% c("groups")) {
			u <- paste(apiurl, "groups.json", sep="/")
			req <- httr::GET(u, query = list(key = key))
			# Check the API call for a valid response
			apiCheck(req)

			# If check didn't fail, parse the content
			raw <- apiParse(req)
			dt <- raw[[1]]
			if (is.null(dim(dt))) {
				stop("Groups are not available for the selected API endpoint.")
			}
		} else if (type == "values") {
			u <- paste0(apiurl, "/variables/", variable_name, ".json")
			req <- httr::GET(u, query = list(key = key))
			# Check the API call for a valid response
			apiCheck(req)

			# If check didn't fail, parse the content
			raw <- apiParse(req)
			if (length(raw$values) == 0 | !("item" %in% names(raw$values))) {
				stop(paste("Value labels are not available for the selected variable:", variable_name))
			}
			dt <- utils::stack(raw$values$item)
			colnames(dt) <- c("label", "code")
			dt <- dt[, c("code", "label")]

		}	else {
			stop(paste('For "type", you entered: "', type, '". Did you mean "variables", "geographies", "groups", or "values"?', sep = ""))
		}
		return(dt)
	}

#' Use variable metadata to find variables containing a given string
#'
#' Return a list of variable names or data frame of variable metadata containing
#' a given string. This can be used create a list of variables to later pass to
#' getCensus, or a data frame documenting variables used in a given project.
#'
#' @family metadata
#' @param name API programmatic name - e.g. acs/acs5. Use `listCensusApis()` to
#'   see valid dataset names.
#' @param vintage Vintage (year) of dataset. Not required for timeseries APIs.
#' @param find A string to find in the variable metadata.
#' @param varsearch Optional argument specifying which fields to search. Default
#'   is "all". Options are "all", "name", "label", or "concept".
#' @param output Optional argument, specifying output to "list" or "dataframe".
#'   Default is "list".
#' @returns A data frame containing variable metadata
#' @examplesIf has_api_key()
#' # Return a list, and then use getCensus function to retrieve those variables
#' myvars <- makeVarlist(name = "timeseries/poverty/saipe",
#'   find = "Ages 0-4",
#'   varsearch = "label")
#' myvars
#' saipe_dt <- getCensus(name = "timeseries/poverty/saipe",
#'   time = 2016,
#'   vars = myvars,
#'   region = "state:*")
#' head(saipe_dt)
#'
#' @export
makeVarlist <- function(name, vintage = NULL, find, varsearch = "all", output = "list") {
	df <- listCensusMetadata(name, vintage, type = "variables")
	index_name <- with(df, grepl(find, name, ignore.case = T))
	index_label <- with(df, grepl(find, label, ignore.case = T))
	index_concept <- with(df, grepl(find, concept, ignore.case = T))
	if (varsearch == "all") {
		vartable <- df[index_name|index_label|index_concept, ]
	} else if (varsearch == "name") {
		vartable <- df[index_name, ]
	} else if (varsearch == "label") {
		vartable <- df[index_label, ]
	} else if (varsearch == "concept") {
		vartable <- df[index_concept, ]
	}
	if (output == "dataframe") {
		return(vartable)
	} else {
		varlist <- vartable$name
		return(varlist)
	}
}

---
title: "censusapi"
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{censusapi}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

```{r, include = FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  comment = "#>"
)
```

```{r setup}
library(censusapi)
```

See the censusapi website for full documentation: <https://www.hrecht.com/censusapi/index.html>.

Several web-only articles are available at <https://www.hrecht.com/censusapi/articles/>.

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/metadata_functions.R
\name{listCensusApis}
\alias{listCensusApis}
\title{Get general information about available datasets}
\usage{
listCensusApis(name = NULL, vintage = NULL, key = NULL)
}
\arguments{
\item{name}{Optional complete or partial API dataset programmatic name. For
example, "acs", "acs/acs5", "acs/acs5/subject". If using a partial name,
this needs to be the left-most part of the dataset name before \code{/}, e.g.
"timeseries/eits" or "dec" or "acs/acs5".}

\item{vintage}{Optional vintage (year) of dataset.}

\item{key}{A Census API key, obtained at
\url{https://api.census.gov/data/key_signup.html}. If you have a \code{CENSUS_KEY} or
\code{CENSUS_API_KEY} stored in your .Renviron file, getCensus() will
automatically use that key.}
}
\value{
A data frame with the following columns:
\itemize{
\item title: Short written description of the dataset.
\item name: Programmatic name of the dataset.
\item vintage: Year of the survey, for use with microdata and aggregate datasets.
\item type: Dataset type, which is either "Aggregate", "Microdata", or "Timeseries".
\item temporal: Time period of the dataset. Warning: not always documented.
\item spatial: Spatial region of the dataset. Warning: not always documented.
\item url: Base URL of the dataset endpoint.
\item modified: Date last modified. Warning: sometimes out of date.
\item description: Long written description of the dataset.
\item contact: Email address for specific questions about the Census Bureau survey.
}
}
\description{
Scrapes \url{https://api.census.gov/data.json} and returns a dataframe that
includes columns for dataset title, description, name, vintage, url, dataset
type, and other useful fields.
}
\examples{
\dontshow{if (has_api_key()) withAutoprint(\{ # examplesIf}
# Get information about every dataset available in the APIs
apis <- listCensusApis()
head(apis)

# Get information about all vintage 2022 datasets
apis_2022 <- listCensusApis(vintage = 2022)
head(apis_2022)

# Get information about all timeseries datasets
apis_timeseries <- listCensusApis(name = "timeseries")
head(apis_timeseries)

# Get information about 2020 Decennial Census datasets
apis_decennial_2020 <- listCensusApis(name = "dec", vintage = 2020)
head(apis_decennial_2020)

# Get information about one particular dataset
api_sahie <- listCensusApis(name = "timeseries/healthins/sahie")
head(api_sahie)
\dontshow{\}) # examplesIf}
}
\seealso{
Other metadata:
\code{\link[=listCensusMetadata]{listCensusMetadata()}},
\code{\link[=makeVarlist]{makeVarlist()}}
}
\concept{metadata}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/api-key.R
\name{get_api_key}
\alias{get_api_key}
\title{Retrieve a Census API key stored the .Renivron file}
\usage{
get_api_key()
}
\value{
A CENSUS_KEY or CENSUS_API_KEY string stored in the user's .Renviron.
file, or a warning message printed once per R session if none is found.
}
\description{
Retrieve a Census API key stored the .Renivron file
}
\examples{
\dontrun{
get_api_key()
}

}
\seealso{
Other helpers:
\code{\link[=has_api_key]{has_api_key()}}
}
\concept{helpers}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/api-key.R
\name{has_api_key}
\alias{has_api_key}
\title{Is there a saved Census API key in the .Renivron file?}
\usage{
has_api_key()
}
\value{
TRUE or FALSE.
}
\description{
Is there a saved Census API key in the .Renivron file?
}
\examples{
has_api_key()

}
\seealso{
Other helpers:
\code{\link[=get_api_key]{get_api_key()}}
}
\concept{helpers}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getcensus_functions.R
\name{getCensus}
\alias{getCensus}
\title{Retrieve Census data from a given API}
\usage{
getCensus(
  name,
  vintage = NULL,
  key = NULL,
  vars,
  region = NULL,
  regionin = NULL,
  time = NULL,
  show_call = FALSE,
  convert_variables = TRUE,
  year = NULL,
  date = NULL,
  period = NULL,
  monthly = NULL,
  category_code = NULL,
  data_type_code = NULL,
  naics = NULL,
  pscode = NULL,
  naics2012 = NULL,
  naics2007 = NULL,
  naics2002 = NULL,
  naics1997 = NULL,
  sic = NULL,
  ...
)
}
\arguments{
\item{name}{The programmatic name of your dataset, e.g.
"timeseries/poverty/saipe" or "acs/acs5". Use listCensusApis() to see valid
dataset names. Required.}

\item{vintage}{Vintage (year) of dataset, e.g. 2014. Not required for
timeseries APIs.}

\item{key}{A Census API key, obtained at
\url{https://api.census.gov/data/key_signup.html}. If you have a \code{CENSUS_KEY} or
\code{CENSUS_API_KEY} stored in your .Renviron file, getCensus() will
automatically use that key.}

\item{vars}{List of variables to get. Required.}

\item{region}{Geography to get.}

\item{regionin}{Optional hierarchical geography to limit region.}

\item{time}{Time period of data to get. Required for most timeseries APIs.}

\item{show_call}{Display the underlying API call that was sent to the Census
Bureau. Default is FALSE.}

\item{convert_variables}{Convert columns that are likely numbers into numeric
data. Default is TRUE. If false, all columns will be characters, which is
the type returned by the Census Bureau.}

\item{year, date, period, monthly, category_code, data_type_code, naics, pscode, naics2012, naics2007, naics2002, naics1997, sic}{Optional arguments used in some timeseries data APIs.}

\item{...}{Other valid arguments to pass to the Census API. Note: the APIs
are case sensitive.}
}
\value{
A data frame with results from the specified U.S. Census Bureau dataset.
}
\description{
Retrieve Census data from a given API
}
\examples{
\dontshow{if (has_api_key()) withAutoprint(\{ # examplesIf}
# Get total population and median household income for Census places
# (cities, towns, villages) in a single state from the 5-year American Community Survey.
acs_simple <- getCensus(
  name = "acs/acs5",
  vintage = 2022,
  vars = c("NAME", "B01001_001E", "B19013_001E"),
  region = "place:*",
  regionin = "state:01")
head(acs_simple)

# Get all data from the B08301 variable group, "Means of Transportation to Work."
# This returns estimates as well as margins of error and annotation flags.
acs_group <- getCensus(
  name = "acs/acs5",
  vintage = 2022,
  vars = "group(B08301)",
  region = "state:*")
head(acs_group)

# Retreive 2020 Decennial Census block group data within a specific Census tract,
# using the regionin argument to precisely specify the Census tract, county,
# and state.
decennial_block_group <- getCensus(
	name = "dec/dhc",
	vintage = 2020,
	vars = c("NAME", "P1_001N"),
	region = "block group:*",
	regionin = "state:36+county:027+tract:220300")
head(decennial_block_group)

# Get poverty rates for children and for people of all ages beginning in 2000 using the
# Small Area Income and Poverty Estimates API
saipe <- getCensus(
  name = "timeseries/poverty/saipe",
  vars = c("NAME", "SAEPOVRT0_17_PT", "SAEPOVRTALL_PT"),
  region = "state:01",
  time = "from 2000")
head(saipe)

# Get the number of employees and number of establishments in the construction sector,
# NAICS2017 code 23, using the County Business Patterns API
cbp <- getCensus(
	name = "cbp",
	vintage = 2021,
	vars = c("EMP", "ESTAB", "NAICS2017_LABEL"),
	region = "county:*",
	NAICS2017 = 23)
head(cbp)
\dontshow{\}) # examplesIf}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/datasets.R
\docType{data}
\name{fips}
\alias{fips}
\title{List of state fips codes - 50 states plus DC}
\format{
A list of fips codes for 50 states and the District of Columbia.
}
\usage{
fips
}
\description{
Some small geographies in some Census APIs can only be used under a state hierarchy.
This is a list of fips codes that may be looped over to retrieve data for all states.
}
\examples{
fips
}
\keyword{datasets}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/makevar_functions.R
\name{makeVarlist}
\alias{makeVarlist}
\title{Use variable metadata to find variables containing a given string}
\usage{
makeVarlist(name, vintage = NULL, find, varsearch = "all", output = "list")
}
\arguments{
\item{name}{API programmatic name - e.g. acs/acs5. Use \code{listCensusApis()} to
see valid dataset names.}

\item{vintage}{Vintage (year) of dataset. Not required for timeseries APIs.}

\item{find}{A string to find in the variable metadata.}

\item{varsearch}{Optional argument specifying which fields to search. Default
is "all". Options are "all", "name", "label", or "concept".}

\item{output}{Optional argument, specifying output to "list" or "dataframe".
Default is "list".}
}
\value{
A data frame containing variable metadata
}
\description{
Return a list of variable names or data frame of variable metadata containing
a given string. This can be used create a list of variables to later pass to
getCensus, or a data frame documenting variables used in a given project.
}
\examples{
\dontshow{if (has_api_key()) withAutoprint(\{ # examplesIf}
# Return a list, and then use getCensus function to retrieve those variables
myvars <- makeVarlist(name = "timeseries/poverty/saipe",
  find = "Ages 0-4",
  varsearch = "label")
myvars
saipe_dt <- getCensus(name = "timeseries/poverty/saipe",
  time = 2016,
  vars = myvars,
  region = "state:*")
head(saipe_dt)
\dontshow{\}) # examplesIf}
}
\seealso{
Other metadata:
\code{\link[=listCensusApis]{listCensusApis()}},
\code{\link[=listCensusMetadata]{listCensusMetadata()}}
}
\concept{metadata}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/getcensus_functions.R
\name{getFunction}
\alias{getFunction}
\title{Internal function: Get the API response, return a data frame}
\usage{
getFunction(
  apiurl,
  name,
  key,
  get,
  region,
  regionin,
  time,
  show_call,
  convert_variables,
  year,
  date,
  period,
  monthly,
  category_code,
  data_type_code,
  naics,
  pscode,
  naics2012,
  naics2007,
  naics2002,
  naics1997,
  sic,
  ...
)
}
\description{
Internal function: Get the API response, return a data frame
}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/metadata_functions.R
\name{listCensusMetadata}
\alias{listCensusMetadata}
\title{Get metadata about a specified API endpoint}
\usage{
listCensusMetadata(
  name,
  vintage = NULL,
  key = NULL,
  type = "variables",
  group = NULL,
  variable_name = NULL,
  include_values = FALSE
)
}
\arguments{
\item{name}{API programmatic name - e.g. acs/acs5. Use \code{listCensusApis()} to
see valid dataset names.}

\item{vintage}{Vintage (year) of dataset. Not required for timeseries APIs.}

\item{key}{A Census API key, obtained at
\url{https://api.census.gov/data/key_signup.html}. If you have a \code{CENSUS_KEY} or
\code{CENSUS_API_KEY} stored in your .Renviron file, getCensus() will
automatically use that key.}

\item{type}{Type of metadata to return. Options are:
\itemize{
\item "variables" (default) - list of variable names and descriptions
for the dataset.
\item "geographies" - available geographies.
\item "groups" - available variable groups. Only available
for some datasets.
\item "values" - encoded value labels for a given variable. Pair with
"variable_name". Only available for some datasets.
}}

\item{group}{An optional variable group code, used to return metadata for a
specific group of variables only. Variable groups are not used for all
APIs.}

\item{variable_name}{A name of a specific variable used to return value
labels for that variable. Value labels are not used for all APIs.}

\item{include_values}{Use with \code{type = "variables"}. Include value metadata
for all variables in a dataset if value metadata exists. Default is
"FALSE".}
}
\value{
A data frame with metadata about the specified API endpoint.
}
\description{
Get information about a Census Bureau API dataset, including its available
variables, geographies, variable groups, and value labels
}
\examples{
\dontshow{if (has_api_key()) withAutoprint(\{ # examplesIf}
# type: variables # List the variables available in the Small Area
# Health Insurance Estimates.
variables <- listCensusMetadata(
  name = "timeseries/healthins/sahie", type = "variables")
head(variables)

# type: variables for a single variable group
# List the variables that are included in the B17020 group in the
# 5-year American Community Survey.
variable_group <- listCensusMetadata(
  name = "acs/acs5", vintage = 2022,
  type = "variables", group = "B17020")
head(variable_group)

# type: variables, with value labels
# Create a data dictionary with all variable names and encoded values
# for a microdata API.
variable_values <- listCensusMetadata(
  name = "cps/voting/nov",
  vintage = 2020,
  type = "variables",
  include_values = TRUE)
head(variable_values)

# type: geographies
# List the geographies available in the 5-year American Community Survey.
geographies <- listCensusMetadata(
  name = "acs/acs5",
  vintage = 2022,
  type = "geographies")
head(geographies)

# type: groups
# List the variable groups available in the 5-year American
# Community Survey.
groups <- listCensusMetadata(
  name = "acs/acs5",
  vintage = 2022,
  type = "groups")
head(groups)

# type: values for a single variable
# List the value labels of the NAICS2017 variable in the County
# Business Patterns dataset.
naics_values <- listCensusMetadata(
  name = "cbp",
  vintage = 2021,
  type = "values",
  variable = "NAICS2017")
head(naics_values)
\dontshow{\}) # examplesIf}
}
\seealso{
Other metadata:
\code{\link[=listCensusApis]{listCensusApis()}},
\code{\link[=makeVarlist]{makeVarlist()}}
}
\concept{metadata}
